﻿Imports Microsoft.VisualBasic
Imports System.ComponentModel
Imports System.Data
Imports System.Data.Common

Public Class Book

    <DataObjectMethod(DataObjectMethodType.Select, True)> _
    Public Function getBooksDataReader(ByVal publish As String) As DbDataReader
        Dim setting As ConnectionStringSettings = _
            ConfigurationManager.ConnectionStrings("MyDB")
        Dim factory As DbProviderFactory = _
            DbProviderFactories.GetFactory(setting.ProviderName)
        Dim db As DbConnection = factory.CreateConnection()
        db.ConnectionString = setting.ConnectionString
        Dim comm As DbCommand = factory.CreateCommand()
        comm.Connection = db
        If publish <> "-" Then
            comm.CommandText = _
              "SELECT * FROM books WHERE publish=@publish"
            Dim param As DbParameter = factory.CreateParameter()
            param.ParameterName = "@publish"
            param.Value = publish
            comm.Parameters.Add(param)
        Else
            comm.CommandText = "SELECT * FROM books"
        End If
        db.Open()
        Return comm.ExecuteReader(CommandBehavior.CloseConnection)
    End Function

    <DataObjectMethod(DataObjectMethodType.Select, False)> _
    Public Function getBooksDataSet(ByVal publish As String) As DataSet
        Dim setting As ConnectionStringSettings = _
             ConfigurationManager.ConnectionStrings("MyDB")
        Dim factory As DbProviderFactory = _
            DbProviderFactories.GetFactory(setting.ProviderName)
        Dim db As DbConnection = factory.CreateConnection()
        db.ConnectionString = setting.ConnectionString
        Dim adapter As DbDataAdapter = factory.CreateDataAdapter()
        Dim comm As DbCommand = factory.CreateCommand()
        comm.Connection = db
        If publish <> "-" Then
            comm.CommandText = _
              "SELECT * FROM books WHERE publish=@publish"
            Dim param As DbParameter = factory.CreateParameter()
            param.ParameterName = "@publish"
            param.Value = publish
            comm.Parameters.Add(param)
        Else
            comm.CommandText = "SELECT * FROM books"
        End If
        Dim ds As New DataSet()
        adapter.SelectCommand = comm
        adapter.Fill(ds, "books")
        Return ds
    End Function

    <DataObjectMethod(DataObjectMethodType.Delete, True)> _
    Public Sub deleteBook(ByVal isbn As String)
        Dim setting As ConnectionStringSettings = _
             ConfigurationManager.ConnectionStrings("MyDB")
        Dim factory As DbProviderFactory = _
            DbProviderFactories.GetFactory(setting.ProviderName)
        Using db As DbConnection = factory.CreateConnection()
            db.ConnectionString = setting.ConnectionString
            Dim adapter As DbDataAdapter = factory.CreateDataAdapter()
            Dim comm As DbCommand = factory.CreateCommand()
            comm.CommandText = _
                  "DELETE FROM books WHERE isbn=@isbn"
            comm.Connection = db
            Dim param As DbParameter = factory.CreateParameter()
            param.ParameterName = "@isbn"
            param.Value = isbn
            comm.Parameters.Add(param)
            db.Open()
            comm.ExecuteNonQuery()
        End Using
    End Sub
End Class
